﻿-- arrays to allocate the current localization strings
DailyTrackerCategories = {};
DailyTrackerCategoriesIdMappings = {};
DailyTrackerQuests = {};
DailyTrackerQuestsIdMappings = {};
DailyTrackerStrings = {};

-- arrays to allocate various localizations
DailyTrackerLocalCategories = {};
DailyTrackerLocalQuests = {};
DailyTrackerLocalStrings = {};

-- default locale to load
DailyTrackerLocale_DefaultLocale = "enUS";

function DailyTrackerLocale_LocalizeQuests( locale )	
	if not DailyTrackerLocalQuests[ locale ] then
		return;
	end
	
	local workingIndex = table.getn( DailyTrackerQuests ) + 1;
	for i = 1, table.getn( DailyTrackerLocalQuests[ locale ] ) do
		local quest = DailyTrackerLocalQuests[ locale ][ i ];
		local uniqueQuestId = quest.Category .. "_" .. quest.Id;
		local index = DailyTrackerQuestsIdMappings[ uniqueQuestId ];
		
		if index then
			DailyTrackerQuests[ index ] = quest;
		else
			DailyTrackerQuests[ workingIndex ] = quest;
			DailyTrackerQuestsIdMappings[ uniqueQuestId ] = workingIndex;
			workingIndex = workingIndex + 1;
		end
	end
end

function DailyTrackerLocale_LocalizeCategories( locale )
	if not DailyTrackerLocalCategories[ locale ] then
		return;
	end
	
	local workingIndex = table.getn( DailyTrackerCategories ) + 1;
	for i = 1, table.getn( DailyTrackerLocalCategories[ locale ] ) do
		local cat = DailyTrackerLocalCategories[ locale ][ i ];
		local index = DailyTrackerCategoriesIdMappings[ cat.Id ];
		
		if index then
			DailyTrackerCategories[ index ] = cat;
		else			
			DailyTrackerCategories[ workingIndex ] = cat;
			DailyTrackerCategoriesIdMappings[ cat.Id ] = workingIndex;
			workingIndex = workingIndex + 1;
		end
	end
end

function DailyTrackerLocale_LocalizeStrings( locale )
	if not DailyTrackerLocalStrings[ locale ] then
		return;
	end
	
	for k, v in pairs(DailyTrackerLocalStrings[ locale ]) do
		DailyTrackerStrings[k] = v;
	end
end

function DailyTrackerLocale_Localize( locale )
	DailyTrackerLocale_LocalizeCategories( locale );
	DailyTrackerLocale_LocalizeQuests( locale );
	DailyTrackerLocale_LocalizeStrings( locale );
end
